library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.all;

library AntiReplayCore;
use AntiReplayCore.AntiReplayCore; 

entity example is
end example;

architecture rtl of example is
    signal clock : STD_LOGIC;



    signal bitmap_wr_write : STD_LOGIC;
    signal bitmap_wr_writedata : STD_LOGIC_VECTOR(255 downto 0);
    signal bitmap_wr_address : STD_LOGIC_VECTOR(19 downto 0);
    signal bitmap_rd_readdata : STD_LOGIC_VECTOR(255 downto 0);
    signal bitmap_rd_read : STD_LOGIC;
    signal bitmap_rd_address : STD_LOGIC_VECTOR(19 downto 0);
    signal out_result_data : STD_LOGIC_VECTOR(2 downto 0);
    signal out_result_valid : STD_LOGIC;
    signal out_frame_userdata : STD_LOGIC_VECTOR(-1 downto 0);
    signal out_frame_channel : STD_LOGIC_VECTOR(0 downto 0);
    signal out_frame_error : STD_LOGIC_VECTOR(0 downto 0);
    signal out_frame_empty : STD_LOGIC_VECTOR(5 downto 0);
    signal out_frame_endofpacket : STD_LOGIC;
    signal out_frame_startofpacket : STD_LOGIC;
    signal out_frame_data : STD_LOGIC_VECTOR(511 downto 0);
    signal out_frame_valid : STD_LOGIC;
    signal out_ready : STD_LOGIC;
    signal in_frame_userdata : STD_LOGIC_VECTOR(-1 downto 0);
    signal in_frame_channel : STD_LOGIC_VECTOR(0 downto 0);
    signal in_frame_error : STD_LOGIC_VECTOR(0 downto 0);
    signal in_frame_empty : STD_LOGIC_VECTOR(5 downto 0);
    signal in_frame_endofpacket : STD_LOGIC;
    signal in_frame_startofpacket : STD_LOGIC;
    signal in_frame_data : STD_LOGIC_VECTOR(511 downto 0);
    signal in_frame_valid : STD_LOGIC;
    signal in_ready : STD_LOGIC;
    signal in_cmd_windowSize : STD_LOGIC_VECTOR(23 downto 0);
    signal in_cmd_sequenceNumber : STD_LOGIC_VECTOR(63 downto 0);
    signal in_cmd_connectionIndex : STD_LOGIC_VECTOR(13 downto 0);
    signal in_cmd_opcode : STD_LOGIC_VECTOR(2 downto 0);
    signal in_cmd_valid : STD_LOGIC;

begin

    example_instance: entity AntiReplayCore.AntiReplayCore port map (
        clock => clock,
        bitmap_wr_write => bitmap_wr_write,
        bitmap_wr_writedata => bitmap_wr_writedata,
        bitmap_wr_address => bitmap_wr_address,
        bitmap_rd_readdata => bitmap_rd_readdata,
        bitmap_rd_read => bitmap_rd_read,
        bitmap_rd_address => bitmap_rd_address,
        out_result_data => out_result_data,
        out_result_valid => out_result_valid,
        out_frame_userdata => out_frame_userdata,
        out_frame_channel => out_frame_channel,
        out_frame_error => out_frame_error,
        out_frame_empty => out_frame_empty,
        out_frame_endofpacket => out_frame_endofpacket,
        out_frame_startofpacket => out_frame_startofpacket,
        out_frame_data => out_frame_data,
        out_frame_valid => out_frame_valid,
        out_ready => out_ready,
        in_frame_userdata => in_frame_userdata,
        in_frame_channel => in_frame_channel,
        in_frame_error => in_frame_error,
        in_frame_empty => in_frame_empty,
        in_frame_endofpacket => in_frame_endofpacket,
        in_frame_startofpacket => in_frame_startofpacket,
        in_frame_data => in_frame_data,
        in_frame_valid => in_frame_valid,
        in_ready => in_ready,
        in_cmd_windowSize => in_cmd_windowSize,
        in_cmd_sequenceNumber => in_cmd_sequenceNumber,
        in_cmd_connectionIndex => in_cmd_connectionIndex,
        in_cmd_opcode => in_cmd_opcode,
        in_cmd_valid => in_cmd_valid
    );

end architecture;
