
# This script is intended for adding the core to an existing project
#     1. Open the quartus tcl console (View->Utility Windows->Tcl Console) 
#     2. If necessary, change the current working directory to project directory ("cd [get_project_directory]")
#     3. Source this script ("source path/to/this/script.tcl"). Use a relative path to this script if you want files to be added with relative paths (recommended).


package require ::quartus::project

set projectDirectory [get_project_directory]
set currentDirectory [pwd]/

if {$currentDirectory != $projectDirectory} {
	puts "The current working directory must be the project directory!"
	puts "Current working directory: $currentDirectory"
	puts "Project directory: $projectDirectory"
} else {
	variable scriptLocation [info script]
	set directory [file dirname $scriptLocation]
	set pathType [file pathtype $directory]

	puts "The path to the script and files seems to be $directory so prepending filenames with this path."

	if {$pathType != "relative"} {
		puts "Warning: The files are prefixed with an absolute path which breaks the project if it is moved around. Source this tcl script with a relative path if you want relative paths in your project file!"
	}


    set_global_assignment -name SDC_FILE $directory/constraints.sdc
    set_global_assignment -name VHDL_FILE -hdl_version VHDL_2008 $directory/AntiReplayCore.vhd -library AntiReplayCore

	export_assignments
}
