/*  This file is part of Gatery, a library for circuit design.
    Copyright (C) 2021 Michael Offel, Andreas Ley

    Gatery is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    Gatery is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "gatery/pch.h"

#include "M9K.h"

namespace gtry::scl::arch::intel {

M9K::M9K(const IntelDevice &intelDevice) : IntelBlockram(intelDevice)
{
	m_desc.memoryName = "M9K";

	// Embedded Memory User Guide "Table 3. Embedded Memory Blocks in Intel FPGA Devices"
    m_desc.size = 9 << 10;
    
	// MAX 10 Embedded Memory User Guide "Table 8. Valid Range of Maximum Block Depth for M9K Memory Blocks"
	m_desc.addressBits = 13; // 8192
}

}