function ReadFileAsArray(name, out_file)
    local first_line = true
    local f = assert(io.open(name, "rb"))
    while true do
        local bytes = f:read(24)
        if not bytes then 
            break 
        end

        if first_line then
            first_line = false
        else
            out_file:write(',')
        end
        out_file:write("\n\t")
        for i = 1, #bytes do
            if i ~= 1 then
                out_file:write(',')
            end
            out_file:write(string.format("0x%02X", bytes:byte(i)))
        end
        --out_file:write("")
    end
end

function EmbedResources(name, prefix_path, pattern)

    local symbol_list = "\n\nstruct { const char* name; const unsigned char* data; unsigned size; } res_" .. name .. "[] = {\n"

    local rf = io.open(name .. ".h", "wb")
    local resource_files = os.matchfiles(prefix_path .. pattern)
    for i = 1, #resource_files do
        local file_name = resource_files[i]:sub(#prefix_path + 1)
        local symbol_name = file_name:gsub('[%p%c%s]', '_')

        io.write("Embed into " .. name .. ": " .. file_name .. "\n")
        rf:write("static const unsigned char " .. symbol_name .. "[] = {")
        ReadFileAsArray(resource_files[i], rf)
        rf:write("};\n")

        symbol_list = symbol_list .. "\t{\"" .. file_name .. "\", " .. symbol_name .. ", sizeof(" .. symbol_name .. ") },\n"
    end
    symbol_list = symbol_list .. "};\n"

    rf:write(symbol_list)
    files(name .. ".h")
end

project "synogate"
    kind "StaticLib"
    files "synogate/**"
    includedirs "../../gatery/source"
    EmbedResources("synogate_data", "../data/", "**")


