/*
	Synogate Library, a support library for Synogate IP-core generators.
	Copyright (C) 2021 Synogate UG (haftungsbeschraenkt), www.synogate.com 
	
	This program is commercial software: you must not copy, modify or
	distribute it without explicit written license by Synogate to do so. 
	
	The full license text for non-commercial use and evaluation can be found in the distribution package of this core.
	
	This program is distributed WITHOUT ANY WARRANTY; without even the
	implied warranty of MERCHANTABILITY.
*/

#pragma once

#include <sstream>
#include <string>

namespace gtry::reporting {

class Report;

class Float
{
    public:
        Float(Report &report, std::string name, std::string label);
        virtual ~Float() = default;

        template<typename type>
        Float &operator<<(const type &v) { m_caption << v; return *this; }

        const std::string &getName() const { return m_name; }
        const std::string &getLabel() const { return m_label; }
        const std::stringstream &getCaption() const { return m_caption; }
    protected:
        Report &m_report;
        std::string m_name;
        std::string m_label;
        std::stringstream m_caption;

};


}