/*
	Synogate Library, a support library for Synogate IP-core generators.
	Copyright (C) 2021 Synogate UG (haftungsbeschraenkt), www.synogate.com 
	
	This program is commercial software: you must not copy, modify or
	distribute it without explicit written license by Synogate to do so. 
	
	The full license text for non-commercial use and evaluation can be found in the distribution package of this core.
	
	This program is distributed WITHOUT ANY WARRANTY; without even the
	implied warranty of MERCHANTABILITY.
*/

#include "Section.h"

#include "Table.h"
#include "Waveform.h"


namespace gtry::reporting {

Section::Section(Report &report, std::string name, std::string label) :
            m_report(report), m_name(std::move(name)), m_label(std::move(label))
{
}

Section::~Section()
{
}

Section &Section::addSection(std::string name, std::string label)
{
    m_subSections.emplace_back(m_report, std::move(name), std::move(label));
    return m_subSections.back();
}


}