/*
	Synogate Library, a support library for Synogate IP-core generators.
	Copyright (C) 2021 Synogate UG (haftungsbeschraenkt), www.synogate.com 
	
	This program is commercial software: you must not copy, modify or
	distribute it without explicit written license by Synogate to do so. 
	
	The full license text for non-commercial use and evaluation can be found in the distribution package of this core.
	
	This program is distributed WITHOUT ANY WARRANTY; without even the
	implied warranty of MERCHANTABILITY.
*/

#include "Waveform.h"

namespace gtry::reporting {


Waveform::Style Waveform::defaultInHex = {
    .cssPrefix = "wf_defined_input",
    .base = 16
};

Waveform::Style Waveform::defaultInBin = {
    .cssPrefix = "wf_defined_input",
    .angledTransitions = false,
    .showLabel = false,
    .base = 2
};

Waveform::Style Waveform::defaultHex = {
    .cssPrefix = "wf_defined",
    .base = 16
};

Waveform::Style Waveform::defaultBin = {
    .cssPrefix = "wf_defined",
    .angledTransitions = false,
    .showLabel = false,
    .base = 2
};

Waveform::Style Waveform::defaultClock = {
    .cssPrefix = "wf_clock",
    .angledTransitions = false,
    .showLabel = false,
    .verticalRulerRisingEdge = true,
    .verticalRulerFallingEdge = false,
    .base = 2
};

Waveform::Waveform(Report &report, std::string name, std::string label) : Float(report, std::move(name), std::move(label))
{
}

void Waveform::fromMemoryTrace(const sim::MemoryTrace &trace, std::vector<TraceSignal> signals, TraceOptions options)
{
    m_trace = &trace;
    m_signals = std::move(signals);
    m_options = options;
}

}