workspace "anti-replay-core"
    configurations { "Debug", "Release" }
    architecture "x64"
    symbols "On"
    flags { "MultiProcessorCompile" }
    cppdialect "C++latest"
    startproject "anti-replay-core"
    disablewarnings { "4146" } -- disable boost rational still unsigned warning

    targetdir "%{wks.location}/bin/%{cfg.system}-%{cfg.architecture}-%{cfg.longname}"
    objdir "%{wks.location}/obj/%{cfg.system}-%{cfg.architecture}-%{cfg.longname}"

    defines "NOMINMAX"

    filter "configurations:Debug"
        runtime "Debug"
        defines "USE_TESTS"

    filter "configurations:Release"
        runtime "Release"
        staticruntime "On"
        optimize "On"

    filter "system:linux"
        buildoptions { "-std=c++2a", "-fcoroutines" }    

include "source/premake5.lua"

include "libs/gatery/source/premake5.lua"
include "libs/gatery/tests/premake5.lua"
include "libs/synogate/source/premake5.lua"



require('vstudio')
local vs = premake.vstudio.vc2010

local function vcpkg(prj)
    premake.w('<PropertyGroup Label="Vcpkg" Condition="\'$(Configuration)|$(Platform)\'==\'Release|x64\'">')
    premake.w('  <VcpkgUseStatic>true</VcpkgUseStatic>')
    premake.w('</PropertyGroup>')
end

premake.override(vs.elements, "project", function(base, prj)
    local calls = base(prj)
    table.insertafter(calls, vs.globals, vcpkg)
    return calls
end)
